/* -*- Mode: C; c-basic-offset: 2; indent-tabs-mode: nil -*-
 *
 * Pigment Render base library
 *
 * Copyright © 2006 Fluendo Embedded S.L. <www.fluendo.com>
 * All rights reserved.
 *
 * This file is available under one of two license agreements.
 *
 * This file is licensed under the GPL version 2. See "LICENSE.GPL" in
 * the root of this distribution including a special exception to use
 * Pigment with Fluendo's plugins.
 *
 * The GPL part of Pigment is also available under a commercial licensing
 * agreement from Fluendo. See "LICENSE.Pigment" in the root directory
 * of this distribution package for details on that license.
 */

#ifndef __PGM_RENDER_PIPE3D_IFACE_H__
#define __PGM_RENDER_PIPE3D_IFACE_H__

#include "pgmrendererror.h"
#include <glib-object.h>

G_BEGIN_DECLS

#define PGM_RENDER_TYPE_PIPE3D_IFACE             (pgm_render_pipe3d_iface_get_type ())
#define PGM_RENDER_PIPE3D_IFACE(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), PGM_RENDER_TYPE_PIPE3D_IFACE, PgmRenderPipe3dIFace))
#define PGM_RENDER_PIPE3D_IFACE_CLASS(vtable)    (G_TYPE_CHECK_CLASS_CAST((vtable), PGM_RENDER_TYPE_PIPE3D_IFACE, GTypeInterface))
#define PGM_RENDER_IS_PIPE3D_IFACE(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), PGM_RENDER_TYPE_PIPE3D_IFACE))
#define PGM_RENDER_IS_PIPE3D_IFACE_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE((vtable), PGM_RENDER_TYPE_PIPE3D_IFACE))
#define PGM_RENDER_PIPE3D_IFACE_GET_CLASS(inst)  (G_TYPE_INSTANCE_GET_INTERFACE((inst), PGM_RENDER_TYPE_PIPE3D_IFACE, PgmRenderPipe3dIFaceClass))

typedef struct _PgmRenderPipe3dIFace      PgmRenderPipe3dIFace;
typedef struct _PgmRenderPipe3dIFaceClass PgmRenderPipe3dIFaceClass;

struct _PgmRenderPipe3dIFaceClass {
  GTypeInterface parent;

  PgmRenderError (*set_translation) (PgmRenderPipe3dIFace *pipe3d, gfloat x, gfloat y, gfloat z);
  PgmRenderError (*get_translation) (PgmRenderPipe3dIFace *pipe3d, gfloat *x, gfloat *y, gfloat *z);
  PgmRenderError (*set_rotation)    (PgmRenderPipe3dIFace *pipe3d, gfloat x, gfloat y, gfloat z);
  PgmRenderError (*get_rotation)    (PgmRenderPipe3dIFace *pipe3d, gfloat *x, gfloat *y, gfloat *z);
};

GType          pgm_render_pipe3d_iface_get_type  (void) G_GNUC_CONST;
PgmRenderError pgm_render_pipe3d_set_translation (PgmRenderPipe3dIFace *pipe3d, gfloat x, gfloat y, gfloat z);
PgmRenderError pgm_render_pipe3d_get_translation (PgmRenderPipe3dIFace *pipe3d, gfloat *x, gfloat *y, gfloat *z);
PgmRenderError pgm_render_pipe3d_set_rotation    (PgmRenderPipe3dIFace *pipe3d, gfloat x, gfloat y, gfloat z);
PgmRenderError pgm_render_pipe3d_get_rotation    (PgmRenderPipe3dIFace *pipe3d, gfloat *x, gfloat *y, gfloat *z);

G_END_DECLS

#endif /* __PGM_RENDER_PIPE3D_IFACE_H__ */
