/* -*- Mode: C; c-basic-offset: 2; indent-tabs-mode: nil -*-
 *
 * Pigment Render OpenGL 1.2 plugin
 *
 * Copyright © 2007 Fluendo Embedded S.L. <www.fluendo.com>
 * All rights reserved.
 *
 * This file is available under one of two license agreements.
 *
 * This file is licensed under the GPL version 2. See "LICENSE.GPL" in
 * the root of this distribution including a special exception to use
 * Pigment with Fluendo's plugins.
 *
 * The GPL part of Pigment is also available under a commercial licensing
 * agreement from Fluendo. See "LICENSE.Pigment" in the root directory
 * of this distribution package for details on that license.
 *
 * Author(s): Colin Laplace <haiku at bloodshed.net>
 *            Loïc Molinari <loic@fluendo.com>
 */

#ifndef __PGM_RENDER_GLX_H__
#define __PGM_RENDER_GLX_H__

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <GL/glx.h>
#include <GL/glxext.h>
#include <glib.h>

typedef gint (*GlxSgiGetVideoSyncFunc)  (guint *count);
typedef gint (*GlxSgiWaitVideoSyncFunc) (gint divisor, gint remainder,
                                         guint *count);

G_BEGIN_DECLS

struct _PgmRenderGlxContext {
  Display                 *display;
  gint                    screen;
  Window                  win;
  Window                  fs_win;
  GLXContext              context;
  gboolean                direct;
  XVisualInfo             *vi;
  XSetWindowAttributes    swa;
  XSetWindowAttributes    fs_swa;
  gint                    randr_size_id;
  gboolean                full_screen;
  gint                    width;
  gint                    height;
  guint                   text_lists;
  const gchar             *extensions;
  GlxSgiGetVideoSyncFunc  get_video_sync;
  GlxSgiWaitVideoSyncFunc wait_video_sync;
  gint dri_fd;
};

void glx_init_context (PgmRenderGl1Window *window);
void glx_fini_context (PgmRenderGl1Window *window);

G_END_DECLS

#endif /* __PGM_RENDER_GLX_H__ */
