/* -*- Mode: C; c-basic-offset: 2; indent-tabs-mode: nil -*-
 *
 * Pigment Render OpenGL 1.2 plugin
 *
 * Copyright © 2006 Fluendo Embedded S.L. <www.fluendo.com>
 * All rights reserved.
 *
 * This file is available under one of two license agreements.
 *
 * This file is licensed under the GPL version 2. See "LICENSE.GPL" in
 * the root of this distribution including a special exception to use
 * Pigment with Fluendo's plugins.
 *
 * The GPL part of Pigment is also available under a commercial licensing
 * agreement from Fluendo. See "LICENSE.Pigment" in the root directory
 * of this distribution package for details on that license.
 *
 * Author: Loïc Molinari <loic@fluendo.com>
 */

#ifndef __PGM_RENDER_GL1_FONT_H__
#define __PGM_RENDER_GL1_FONT_H__

/* FIXME: Correct use of the autotools */
#include "pgmrendergl1.h"
#include <cairo.h>

G_BEGIN_DECLS

#define PGM_RENDER_TYPE_GL1_FONT            (pgm_render_gl1_font_get_type())
#define PGM_RENDER_GL1_FONT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), PGM_RENDER_TYPE_GL1_FONT, PgmRenderGl1Font))
#define PGM_RENDER_GL1_FONT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass), PGM_RENDER_TYPE_GL1_FONT, Drawable))
#define PGM_RENDER_IS_GL1_FONT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), PGM_RENDER_TYPE_GL1_FONT))
#define PGM_RENDER_IS_GL1_FONT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), PGM_RENDER_TYPE_GL1_FONT))
#define PGM_RENDER_GL1_FONT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj), PGM_RENDER_TYPE_GL1_FONT, PgmRenderGl1FontClass))

typedef struct _PgmRenderGl1Font PgmRenderGl1Font;
typedef struct _PgmRenderGl1FontClass PgmRenderGl1FontClass;

struct _PgmRenderGl1Font {
  PgmRenderDrawable     parent;

  /* FIXME: Clean up */
  cairo_surface_t      *text_surface;
  cairo_t              *text_cr;
  cairo_font_options_t *text_font_options;
  cairo_font_extents_t  text_font_extents;
  cairo_text_extents_t  text_text_extents;
  cairo_surface_t      *text_surface_extents;
  cairo_t              *text_cr_extents;
  gchar                *text_font_name;
  cairo_font_slant_t    text_slant;
  cairo_font_weight_t   text_weight;
  gint                  text_size;
  gchar                *text_label;
  guchar               *text_pixels;
  VertexCoord           text_vertex[4];
  TextureCoord          text_coord[4];
  /* Normal                text_normal[4]; */
  Color                 text_color;
  guint                 text_id;
  gint                  text_width;
  gint                  text_height;
  gint                  text_tex_width;
  gint                  text_tex_height;
  gfloat                text_coord_x_limit;
  gfloat                text_coord_y_limit;

  /* */
  gfloat                layout_x;
  gfloat                layout_y;
  gint                  layout_width;
  gint                  layout_height;
  gfloat                layout_x_align;
  gfloat                layout_y_align;
  gfloat                layout_s_offset;
  gfloat                layout_t_offset;

  /* Pipe3d interface */
  gfloat                translation[3];
  gfloat                rotation[3];

  gfloat                sx, sy;
  gfloat                window_sx, window_sy;
};

struct _PgmRenderGl1FontClass {
  PgmRenderDrawableClass parent_class;

  PgmRenderGlBackend     *backend;
  GList                  *font_with_media_data;
};

GType             pgm_render_gl1_font_get_type   (void) G_GNUC_CONST;
PgmRenderGl1Font *pgm_render_gl1_font_new        (void);
void              pgm_render_gl1_font_set_scale  (PgmRenderGl1Font *font, gfloat sx, gfloat sy);
void              pgm_render_gl1_font_regenerate (PgmRenderGl1Font *font);

G_END_DECLS

#endif /* __PGM_RENDER_GL1_FONT_H__ */
